diff --git a/src/main/java/net/minecraft/client/gui/options/components/ToggleableOptionComponent.java b/src/main/java/net/minecraft/client/gui/options/components/ToggleableOptionComponent.java
index 3e5b789a0..24fe3c894 100644
--- a/src/main/java/net/minecraft/client/gui/options/components/ToggleableOptionComponent.java
+++ b/src/main/java/net/minecraft/client/gui/options/components/ToggleableOptionComponent.java
@@ -1,21 +1,21 @@
 package net.minecraft.client.gui.options.components;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiSliderInteger;
+import net.minecraft.client.gui.IntegerSliderElement;
 import net.minecraft.client.option.ToggleableOption;
 
 public class ToggleableOptionComponent<E>
         extends ButtonComponent
 {
     protected final ToggleableOption<E> option;
-    protected final GuiSliderInteger slider;
+    protected final IntegerSliderElement slider;
 
     public ToggleableOptionComponent(ToggleableOption<E> option)
     {
         super("options." + option.name);
 
         this.option = option;
-        this.slider = new GuiSliderInteger(0, 0, 0, 150, 20, option);
+        this.slider = new IntegerSliderElement(0, 0, 0, 150, 20, option);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/options/components/TooltipPickerComponent.java b/src/main/java/net/minecraft/client/gui/options/components/TooltipPickerComponent.java
index e09644359..da66be480 100644
--- a/src/main/java/net/minecraft/client/gui/options/components/TooltipPickerComponent.java
+++ b/src/main/java/net/minecraft/client/gui/options/components/TooltipPickerComponent.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.gui.options.components;
 
-import net.minecraft.client.gui.GuiTooltip;
+import net.minecraft.client.gui.TooltipElement;
 import net.minecraft.client.option.ToggleableOption;
 import net.minecraft.client.option.enums.TooltipStyle;
 import org.lwjgl.opengl.GL11;
@@ -8,19 +8,19 @@ import org.lwjgl.opengl.GL11;
 public class TooltipPickerComponent<E>
     extends ToggleableOptionComponent<E> {
 
-    private final GuiTooltip tooltip;
+    private final TooltipElement tooltip;
 
     public TooltipPickerComponent(ToggleableOption<E> option) {
         super(option);
 
-        this.tooltip = new GuiTooltip(mc);
+        this.tooltip = new TooltipElement(mc);
     }
 
     @Override
     protected void renderButton(int x, int y, int relativeButtonX, int relativeButtonY, int buttonWidth, int buttonHeight, int relativeMouseX, int relativeMouseY) {
         super.renderButton(x, y, relativeButtonX, relativeButtonY, buttonWidth, buttonHeight, relativeMouseX, relativeMouseY);
 
-        int stringWidth = mc.fontRenderer.getStringWidth(this.option.getDisplayStringValue());
+        int stringWidth = mc.font.getStringWidth(this.option.getDisplayStringValue());
         int padding = 3;
         int yOffset = 0;
         if (this.option.value != TooltipStyle.DEFAULT) {
diff --git a/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index efa2030db..bdd4fed5d 100644
--- a/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -1,14 +1,13 @@
 package net.minecraft.client.gui.options.data;
 
-import net.betterthanadventure.utils.BiomeFinder;
 import net.betterthanadventure.utils.DataDumper;
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiControllerSetup;
-import net.minecraft.client.gui.GuiHudDesigner;
-import net.minecraft.client.gui.GuiSoundTest;
-import net.minecraft.client.gui.GuiTextureViewer;
-import net.minecraft.client.gui.achievements.GuiAchievements;
-import net.minecraft.client.gui.modelviewer.GuiModelViewer;
+import net.minecraft.client.gui.ControllerSetupScreen;
+import net.minecraft.client.gui.HudDesignerScreen;
+import net.minecraft.client.gui.SoundTestScreen;
+import net.minecraft.client.gui.TextureViewerScreen;
+import net.minecraft.client.gui.achievements.AchievementsScreen;
+import net.minecraft.client.gui.modelviewer.ModelViewerScreen;
 import net.minecraft.client.gui.options.components.AvailableTexturePackListComponent;
 import net.minecraft.client.gui.options.components.BooleanOptionComponent;
 import net.minecraft.client.gui.options.components.DifficultyOptionComponent;
@@ -33,6 +32,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.util.helper.Utils;
 import net.minecraft.core.world.World;
+import org.useless.seedviewer.SeedViewerMain;
 
 import javax.management.RuntimeErrorException;
 import java.io.File;
@@ -51,7 +51,7 @@ public abstract class OptionsPages
             .withComponent(new BooleanOptionComponent(mc.gameSettings.viewBobbing))
         )
         .withComponent(new OptionsCategory("gui.options.page.general.category.user_interface")
-            .withComponent(new ShortcutComponent("gui.options.page.general.button.edit_hud", () -> mc.displayGuiScreen(new GuiHudDesigner(mc.currentScreen))))
+            .withComponent(new ShortcutComponent("gui.options.page.general.button.edit_hud", () -> mc.displayScreen(new HudDesignerScreen(mc.currentScreen))))
             .withComponent(new IntegerOptionComponent(mc.gameSettings.guiScale))
             .withComponent(new FloatOptionComponent(mc.gameSettings.screenPadding))
             .withComponent(new TooltipPickerComponent<>(mc.gameSettings.tooltipStyle))
@@ -80,6 +80,7 @@ public abstract class OptionsPages
 
     public static final OptionsPage AUDIO = register(new OptionsPage("gui.options.page.audio.title", new ItemStack(Items.RECORD_CAT))
         .withComponent(new OptionsCategory("gui.options.page.audio.category.audio")
+            .withComponent(new BooleanOptionComponent(mc.gameSettings.subtitles))
             .withComponent(new BooleanOptionComponent(mc.gameSettings.muteOnLostFocus))
             .withComponent(new FloatOptionComponent(mc.gameSettings.masterVolume))
             .withComponent(new FloatOptionComponent(mc.gameSettings.musicVolume))
@@ -144,7 +145,7 @@ public abstract class OptionsPages
             .withComponent(new BooleanOptionComponent(mc.gameSettings.swapCraftingButtons))
         )
         .withComponent(new OptionsCategory("gui.options.page.controls.category.controller")
-            .withComponent(new ShortcutComponent("gui.options.page.controls.button.controller_setup", () -> mc.displayGuiScreen(new GuiControllerSetup(mc.currentScreen))))
+            .withComponent(new ShortcutComponent("gui.options.page.controls.button.controller_setup", () -> mc.displayScreen(new ControllerSetupScreen(mc.currentScreen))))
             .withComponent(new FloatOptionComponent(mc.gameSettings.controllerSensitivity))
             .withComponent(new FloatOptionComponent(mc.gameSettings.controllerMenuSensitivity))
             .withComponent(new FloatOptionComponent(mc.gameSettings.controllerDeadzoneLeft))
@@ -281,7 +282,7 @@ public abstract class OptionsPages
             .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.model_viewer", () -> {
                                mc.playerController = new PlayerControllerSP(mc);
                                mc.changeWorld(new World(), "Loading Model Viewer");
-                               mc.displayGuiScreen(new GuiModelViewer());}) {
+                               mc.displayScreen(new ModelViewerScreen());}) {
                                @Override
                                public void render(int x, int y, int width, int relativeMouseX, int relativeMouseY) {
                                    button.enabled = mc.theWorld == null;
@@ -289,10 +290,10 @@ public abstract class OptionsPages
                                }
                            }
             )
-            .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.sound_test", () -> mc.displayGuiScreen(new GuiSoundTest(mc.currentScreen))))
-            .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.texture_viewer", () -> mc.displayGuiScreen(new GuiTextureViewer(mc.currentScreen))))
+            .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.sound_test", () -> mc.displayScreen(new SoundTestScreen(mc.currentScreen))))
+            .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.texture_viewer", () -> mc.displayScreen(new TextureViewerScreen(mc.currentScreen))))
             .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.biome_finder", () -> {
-                new Thread(() -> BiomeFinder.main(new String[0])).start();
+                new Thread(() -> SeedViewerMain.main(new String[0])).start();
                 Global.accessor = mc;
             }))
             .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.datadumper", () ->{
@@ -300,7 +301,7 @@ public abstract class OptionsPages
                 Utils.openDirectory(new File(mc.getMinecraftDir(), "infodump"));
                 Global.accessor = mc;
             }))
-            .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.achievements", () -> mc.displayGuiScreen(new GuiAchievements(mc.currentScreen, mc.statsCounter))))
+            .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.achievements", () -> mc.displayScreen(new AchievementsScreen(mc.currentScreen, mc.statsCounter))))
         )
         .withComponent(new OptionsCategory("gui.options.page.debug.category.test")
             .withComponent(new ShortcutComponent("gui.options.page.debug.button.music.skip", () -> {
diff --git a/src/main/java/net/minecraft/client/gui/paged/GuiPaged.java b/src/main/java/net/minecraft/client/gui/paged/PagedScreen.java
similarity index 83%
rename from src/main/java/net/minecraft/client/gui/paged/GuiPaged.java
rename to src/main/java/net/minecraft/client/gui/paged/PagedScreen.java
index 8439fdd2f..53e7b8ea5 100644
--- a/src/main/java/net/minecraft/client/gui/paged/GuiPaged.java
+++ b/src/main/java/net/minecraft/client/gui/paged/PagedScreen.java
@@ -1,8 +1,8 @@
 package net.minecraft.client.gui.paged;
 
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.GuiRenderItem;
-import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.ItemElement;
+import net.minecraft.client.gui.Screen;
 import net.minecraft.client.render.Scissor;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.lang.I18n;
@@ -14,8 +14,8 @@ import org.lwjgl.opengl.GL11;
 import static org.lwjgl.opengl.GL11.*;
 import static org.lwjgl.opengl.GL11.GL_TEXTURE_2D;
 
-public class GuiPaged
-    extends GuiScreen {
+public class PagedScreen
+    extends Screen {
     private static final int TOP_SPACING = 24;
     private static final int BUTTON_SPACING = 4;
     private static final int SEPARATOR_WIDTH = 8;
@@ -35,11 +35,11 @@ public class GuiPaged
     private Page selectedPage;
     private PageComponent clickedComponent;
     private int clickedComponentY;
-    private GuiRenderItem renderItem = null;
+    private ItemElement renderItem = null;
 
     private final PageRegistry pageRegistry;
 
-    public GuiPaged(GuiScreen parent, PageRegistry pageRegistry, Page selectedPage, String titleTranslationKey, String[] buttonTranslationKeys)
+    public PagedScreen(Screen parent, PageRegistry pageRegistry, Page selectedPage, String titleTranslationKey, String[] buttonTranslationKeys)
     {
         super(parent);
         this.pageRegistry = pageRegistry;
@@ -57,7 +57,7 @@ public class GuiPaged
         int totalButtonsWidth = buttonTranslationKeys.length * (buttonWidth + 4) - 4;
         for (int i = 0; i < buttonTranslationKeys.length; i++) {
             String buttonTranslationKey = buttonTranslationKeys[i];
-            controlList.add(new GuiButton(i, width / 2 - totalButtonsWidth / 2 + ((buttonWidth + 4) * i), height - (BUTTON_SPACING + 20), buttonWidth, 20, I18n.getInstance().translateKey(buttonTranslationKey)));
+            buttons.add(new ButtonElement(i, width / 2 - totalButtonsWidth / 2 + ((buttonWidth + 4) * i), height - (BUTTON_SPACING + 20), buttonWidth, 20, I18n.getInstance().translateKey(buttonTranslationKey)));
         }
 
         top = TOP_SPACING;
@@ -66,22 +66,22 @@ public class GuiPaged
         rightScrollRegionHeight = bottom - top;
         leftScrollRegionHeight = bottom - top;
 
-        this.renderItem = new GuiRenderItem(mc);
+        this.renderItem = new ItemElement(mc);
 
         this.selectedPage.initComponents(mc);
     }
 
     @Override
-    public void keyTyped(char c, int key, int mouseX, int mouseY) {
-        if (key == Keyboard.KEY_ESCAPE)
+    public void keyPressed(char eventCharacter, int eventKey, int mx, int my) {
+        if (eventKey == Keyboard.KEY_ESCAPE)
         {
-            mc.displayGuiScreen(getParentScreen());
+            mc.displayScreen(getParentScreen());
         }
         else
         {
             for (PageComponent component : selectedPage.getComponents())
             {
-                component.onKeyPress(key, c);
+                component.onKeyPress(eventKey, eventCharacter);
             }
         }
     }
@@ -108,7 +108,7 @@ public class GuiPaged
                 textColor = 0xFFFFFFA0;
             }
             renderItem.render(page.getIcon(), x, y2 + (PAGE_BUTTON_HEIGHT / 2) - 9);
-            mc.fontRenderer.drawStringWithShadow(translated, x + 19, y2 + (PAGE_BUTTON_HEIGHT / 2) - 4, textColor);
+            mc.font.drawStringWithShadow(translated, x + 19, y2 + (PAGE_BUTTON_HEIGHT / 2) - 4, textColor);
             y2 += PAGE_BUTTON_HEIGHT;
         }
     }
@@ -122,12 +122,12 @@ public class GuiPaged
     }
 
     @Override
-    protected void buttonPressed(GuiButton guibutton) {
-        super.buttonPressed(guibutton);
+    protected void buttonClicked(ButtonElement button) {
+        super.buttonClicked(button);
 
-        if (guibutton.id == 0)
+        if (button.id == 0)
         {
-            mc.displayGuiScreen(getParentScreen());
+            mc.displayScreen(getParentScreen());
             mc.texturePackList.refreshIfReady(); // Sets the texturepacks on menu close
         }
     }
@@ -173,16 +173,16 @@ public class GuiPaged
     }
 
     @Override
-    public void drawScreen(int mouseX, int mouseY, float renderPartialTicks)
+    public void render(int xm, int ym, float renderPartialTicks)
     {
-        if (mouseX > leftWidth + SEPARATOR_WIDTH + PADDING && mouseX < width) {
+        if (xm > leftWidth + SEPARATOR_WIDTH + PADDING && xm < width) {
             if (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL)) {
                 scrollRightPanel(Mouse.getDWheel() / -0.01f);
             } else {
                 scrollRightPanel(Mouse.getDWheel() / -0.05f);
             }
             onScrollRightPanel();
-        } else if (mouseX >= 0 && mouseX <= leftWidth) {
+        } else if (xm >= 0 && xm <= leftWidth) {
             if (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL)) {
                 scrollLeftPanel(Mouse.getDWheel() / -0.01f);
             } else {
@@ -195,13 +195,13 @@ public class GuiPaged
         pageWidth = width - (leftWidth + SEPARATOR_WIDTH + (PADDING * 2));
         I18n i18n = I18n.getInstance();
 
-        drawDefaultBackground();
+        renderBackground();
         overlayBackground(0, width, 0, top);
         overlayBackground(0, width, bottom, height);
 
         Scissor.enable(0, top, width, bottom - top);
-        if (mouseY >= top && mouseY <= bottom) {
-            drawPageItems(leftWidth + SEPARATOR_WIDTH + PADDING, top - (int) rightScrollAmount, pageWidth - 8, mouseX, mouseY);
+        if (ym >= top && ym <= bottom) {
+            drawPageItems(leftWidth + SEPARATOR_WIDTH + PADDING, top - (int) rightScrollAmount, pageWidth - 8, xm, ym);
         } else {
             drawPageItems(leftWidth + SEPARATOR_WIDTH + PADDING, top - (int) rightScrollAmount, pageWidth - 8, -1, -1);
         }
@@ -213,8 +213,8 @@ public class GuiPaged
         if (pagesListHeight < bottom - top) {
             pagesListY = top + (bottom - top - pagesListHeight) / 2;
         }
-        if (mouseY >= top && mouseY <= bottom) {
-            drawPagesListItems(PADDING - 4, pagesListY, leftWidth - PADDING, mouseX, mouseY);
+        if (ym >= top && ym <= bottom) {
+            drawPagesListItems(PADDING - 4, pagesListY, leftWidth - PADDING, xm, ym);
         } else {
             drawPagesListItems(PADDING - 4, pagesListY, leftWidth - PADDING, -1, -1);
         }
@@ -258,12 +258,12 @@ public class GuiPaged
 
         overlayBackground(leftWidth, leftWidth + SEPARATOR_WIDTH, top, bottom);
 
-        drawStringCentered(fontRenderer, i18n.translateKey(titleTranslationKey), width / 2, 5, 0xffffff);
+        drawStringCentered(font, i18n.translateKey(titleTranslationKey), width / 2, 5, 0xffffff);
 
-        drawRightPanelScrollBar(mouseX, mouseY);
-        drawLeftPanelScrollBar(mouseX, mouseY);
+        drawRightPanelScrollBar(xm, ym);
+        drawLeftPanelScrollBar(xm, ym);
 
-        super.drawScreen(mouseX, mouseY, renderPartialTicks);
+        super.render(xm, ym, renderPartialTicks);
     }
 
     protected void drawRightPanelScrollBar(int mouseX, int mouseY) {
@@ -357,32 +357,32 @@ public class GuiPaged
     }
 
     @Override
-    public void mouseClicked(int mouseX, int mouseY, int mouseButton)
+    public void mouseClicked(int mx, int my, int buttonNum)
     {
-        super.mouseClicked(mouseX, mouseY, mouseButton);
+        super.mouseClicked(mx, my, buttonNum);
 
         int left = leftWidth + SEPARATOR_WIDTH + PADDING;
 
-        if (mouseX >= leftWidth + SEPARATOR_WIDTH && mouseY >= top && mouseY <= bottom) {
+        if (mx >= leftWidth + SEPARATOR_WIDTH && my >= top && my <= bottom) {
             int componentY = top - (int) rightScrollAmount;
             for (PageComponent component : selectedPage.getComponents())
             {
-                if (mouseX >= left && mouseX <= left + pageWidth - PADDING && mouseY >= componentY && mouseY <= componentY + component.getHeight()) {
-                    component.onMouseClick(mouseButton, left, componentY, pageWidth - PADDING, mouseX - left, mouseY - componentY);
+                if (mx >= left && mx <= left + pageWidth - PADDING && my >= componentY && my <= componentY + component.getHeight()) {
+                    component.onMouseClick(buttonNum, left, componentY, pageWidth - PADDING, mx - left, my - componentY);
                     clickedComponent = component;
                     clickedComponentY = componentY;
                     break;
                 }
                 componentY += component.getHeight();
             }
-        } else if (mouseX >= 0 && mouseX <= leftWidth && mouseY >= top && mouseY <= bottom) {
+        } else if (mx >= 0 && mx <= leftWidth && my >= top && my <= bottom) {
             int pagesListHeight = getTotalLeftPanelHeight();
             int pagesListY = top - (int) leftScrollAmount;
             if (pagesListHeight < bottom - top) {
                 pagesListY = top + (bottom - top - pagesListHeight) / 2;
             }
             for(Page page : pageRegistry.getPages()) {
-                if (mouseX >= 0 && mouseX <= leftWidth && mouseY >= pagesListY && mouseY <= pagesListY + PAGE_BUTTON_HEIGHT) {
+                if (mx >= 0 && mx <= leftWidth && my >= pagesListY && my <= pagesListY + PAGE_BUTTON_HEIGHT) {
                     rightScrollAmount = 0;
                     selectedPage = page;
                     this.selectedPage.initComponents(mc);
@@ -394,40 +394,40 @@ public class GuiPaged
             }
         }
 
-        clickX = mouseX;
-        clickY = mouseY;
+        clickX = mx;
+        clickY = my;
     }
 
     @Override
-    public void mouseMovedOrButtonReleased(int mouseX, int mouseY, int mouseButton) {
-        super.mouseMovedOrButtonReleased(mouseX, mouseY, mouseButton);
+    public void mouseReleased(int mx, int my, int buttonNum) {
+        super.mouseReleased(mx, my, buttonNum);
 
         int left = leftWidth + SEPARATOR_WIDTH + PADDING;
-        if (mouseY >= top && mouseY <= bottom) {
+        if (my >= top && my <= bottom) {
             if (clickedComponent != null) {
-                if (mouseButton >= 0) {
-                    clickedComponent.onMouseRelease(mouseButton, left, clickedComponentY, pageWidth, mouseX - left, mouseY - clickedComponentY);
+                if (buttonNum >= 0) {
+                    clickedComponent.onMouseRelease(buttonNum, left, clickedComponentY, pageWidth, mx - left, my - clickedComponentY);
                     clickedComponent = null;
                 } else {
-                    clickedComponent.onMouseMove(left, clickedComponentY, pageWidth, mouseX - left, mouseY - clickedComponentY);
+                    clickedComponent.onMouseMove(left, clickedComponentY, pageWidth, mx - left, my - clickedComponentY);
                 }
             }
         }
 
-        if(mouseButton >= 0) {
+        if(buttonNum >= 0) {
             clickX = null;
             clickY = null;
         }
     }
 
     @Override
-    public void drawDefaultBackground() {
-        super.drawDefaultBackground();
+    public void renderBackground() {
+        super.renderBackground();
 
         if (mc.theWorld == null)
         {
             Tessellator tessellator = Tessellator.instance;
-            mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
+            mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
             float scale = 32F;
             tessellator.startDrawingQuads();
@@ -458,7 +458,7 @@ public class GuiPaged
         if (mc.theWorld == null)
         {
             Tessellator tessellator = Tessellator.instance;
-            mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
+            mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
             float scale = 32F;
             tessellator.startDrawingQuads();
diff --git a/src/main/java/net/minecraft/client/gui/popup/ButtonComponent.java b/src/main/java/net/minecraft/client/gui/popup/ButtonComponent.java
index 6a1a03af7..24e0c1316 100644
--- a/src/main/java/net/minecraft/client/gui/popup/ButtonComponent.java
+++ b/src/main/java/net/minecraft/client/gui/popup/ButtonComponent.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.gui.popup;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.core.lang.I18n;
 
 public class ButtonComponent
@@ -9,7 +9,7 @@ public class ButtonComponent
     private final Minecraft minecraft;
     private final String buttonLabel;
     private final String[] buttonValues;
-    private final GuiButton button;
+    private final ButtonElement button;
     private int value;
 
     public ButtonComponent(int width, String buttonLabel, String[] buttonValues, int defaultValue) {
@@ -22,7 +22,7 @@ public class ButtonComponent
 
         this.value = defaultValue;
 
-        button = new GuiButton(0, 0, 0, width, getHeight(), getButtonLabel());
+        button = new ButtonElement(0, 0, 0, width, getHeight(), getButtonLabel());
     }
 
     private String getButtonLabel() {
diff --git a/src/main/java/net/minecraft/client/gui/popup/ButtonGroupComponent.java b/src/main/java/net/minecraft/client/gui/popup/ButtonGroupComponent.java
index 523845b61..c79783c86 100644
--- a/src/main/java/net/minecraft/client/gui/popup/ButtonGroupComponent.java
+++ b/src/main/java/net/minecraft/client/gui/popup/ButtonGroupComponent.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.gui.popup;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.core.sound.SoundCategory;
 
 public class ButtonGroupComponent
@@ -9,7 +9,7 @@ public class ButtonGroupComponent
 {
     private static final int BUTTON_GAP = 2;
     private final Minecraft minecraft;
-    private final GuiButton[] buttons;
+    private final ButtonElement[] buttons;
 
     public ButtonGroupComponent(int width, String[] buttonLabels, int[] buttonStatusCodes, boolean[] enabled)
     {
@@ -17,7 +17,7 @@ public class ButtonGroupComponent
 
         this.minecraft = Minecraft.getMinecraft(this);
 
-        this.buttons = new GuiButton[buttonLabels.length];
+        this.buttons = new ButtonElement[buttonLabels.length];
 
         int numButtons = this.buttons.length;
         int buttonWidth = (width - (BUTTON_GAP * (numButtons - 1))) / numButtons;
@@ -25,7 +25,7 @@ public class ButtonGroupComponent
         buttonWidth = Math.min(buttonWidth,256);
         for (int i = 0; i < numButtons; i++)
         {
-            buttons[i] = new GuiButton(buttonStatusCodes[i], 0, 0, buttonWidth, getHeight(), buttonLabels[i]);
+            buttons[i] = new ButtonElement(buttonStatusCodes[i], 0, 0, buttonWidth, getHeight(), buttonLabels[i]);
             buttons[i].enabled = enabled[i];
         }
     }
@@ -41,7 +41,7 @@ public class ButtonGroupComponent
     {
         for (int i = 0; i < buttons.length; i++)
         {
-            GuiButton button = buttons[i];
+            ButtonElement button = buttons[i];
 
             button.xPosition = x + (button.width + BUTTON_GAP) * i;
             button.yPosition = y;
@@ -52,7 +52,7 @@ public class ButtonGroupComponent
     @Override
     public void onClick(int x, int y, int button)
     {
-        for (GuiButton b : buttons)
+        for (ButtonElement b : buttons)
         {
             if (b.mouseClicked(minecraft, x, y))
             {
diff --git a/src/main/java/net/minecraft/client/gui/popup/LabelComponent.java b/src/main/java/net/minecraft/client/gui/popup/LabelComponent.java
index b78f9a121..31d7c5ea8 100644
--- a/src/main/java/net/minecraft/client/gui/popup/LabelComponent.java
+++ b/src/main/java/net/minecraft/client/gui/popup/LabelComponent.java
@@ -1,19 +1,19 @@
 package net.minecraft.client.gui.popup;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.FontRenderer;
+import net.minecraft.client.render.Font;
 
 public class LabelComponent
     extends PopupComponent
 {
-    private final FontRenderer fr;
+    private final Font fr;
     private final String text;
     private final int color;
 
     public LabelComponent(int width, String text, int color)
     {
         super(width);
-        this.fr = Minecraft.getMinecraft(this).fontRenderer;
+        this.fr = Minecraft.getMinecraft(this).font;
         this.text = text;
         this.color = color;
     }
@@ -27,7 +27,7 @@ public class LabelComponent
     @Override
     public void render(int x, int y, int mouseX, int mouseY)
     {
-        int middle = (x - GuiPopup.HORIZONTAL_MARGIN) + getWidth() / 2;
+        int middle = (x - PopupScreen.HORIZONTAL_MARGIN) + getWidth() / 2;
 
         fr.drawCenteredString(text, middle, y, color);
     }
diff --git a/src/main/java/net/minecraft/client/gui/popup/ListComponent.java b/src/main/java/net/minecraft/client/gui/popup/ListComponent.java
index 4979e5fb8..c48a547f8 100644
--- a/src/main/java/net/minecraft/client/gui/popup/ListComponent.java
+++ b/src/main/java/net/minecraft/client/gui/popup/ListComponent.java
@@ -7,8 +7,8 @@ import org.lwjgl.input.Mouse;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.GuiTooltip;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.TooltipElement;
 import net.minecraft.core.util.helper.MathHelper;
 
 public class ListComponent
@@ -17,12 +17,12 @@ public class ListComponent
     private final Minecraft minecraft;
     private int selectedItem = 0;
     private float scrollAmount = 0;
-    private final GuiButton[] buttons;
+    private final ButtonElement[] buttons;
     private final int height;
     private int lastX = 0;
     private int lastY = 0;
     private final boolean closeOnItemSelected;
-    private final GuiTooltip tooltip;
+    private final TooltipElement tooltip;
     private final String[] buttonTooltips;
     
     private int scrollbarX;
@@ -40,15 +40,15 @@ public class ListComponent
         this.minecraft = Minecraft.getMinecraft(this);
         this.height = height;
         this.closeOnItemSelected = closeOnItemSelected;
-        this.tooltip = new GuiTooltip(minecraft);
+        this.tooltip = new TooltipElement(minecraft);
 
         this.selectedItem = selectedItem;
         this.buttonTooltips = buttonTooltips;
 
-        this.buttons = new GuiButton[buttonLabels.length];
+        this.buttons = new ButtonElement[buttonLabels.length];
         for (int i = 0; i < this.buttons.length; i++)
         {
-            this.buttons[i] = new GuiButton(i, 0, 0, width - 2 - 6, 20, buttonLabels[i]);
+            this.buttons[i] = new ButtonElement(i, 0, 0, width - 2 - 6, 20, buttonLabels[i]);
             if (i == selectedItem)
             {
                 this.buttons[i].enabled = false;
@@ -118,7 +118,7 @@ public class ListComponent
                 buttons[i].width = getWidth() - 2;
             }
 
-            GuiButton button = buttons[i];
+            ButtonElement button = buttons[i];
             button.xPosition = x + 1;
             button.yPosition = (y + 1) + (i * 20) - getScrollPixels();
             if (mouseInRegion(x, y, mouseX, mouseY))
@@ -137,7 +137,7 @@ public class ListComponent
         {
             for (int i = 0; i < buttons.length; i++)
             {
-                GuiButton button = buttons[i];
+                ButtonElement button = buttons[i];
                 if (button.isHovered(mouseX, mouseY))
                 {
                     tooltip.render(buttonTooltips[i], mouseX, mouseY, 0, 0);
@@ -180,11 +180,11 @@ public class ListComponent
         
         if (mouseInRegion(lastX, lastY, x, y))
         {
-            for (GuiButton b : this.buttons)
+            for (ButtonElement b : this.buttons)
             {
                 if (b.mouseClicked(minecraft, x, y))
                 {
-                    for (GuiButton b2 : this.buttons)
+                    for (ButtonElement b2 : this.buttons)
                     {
                         b2.enabled = true;
                     }
